"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var loggers = require("./defines");
/**
 * The logger that write logs into console.
 */
var ConsoleLogger = (function (_super) {
    __extends(ConsoleLogger, _super);
    function ConsoleLogger() {
        _super.call(this);
        this.logWriters = {};
    }
    ConsoleLogger.prototype.log = function (logText, logType, cb) {
        var writer;
        if (!logType) {
            logType = this.defType;
        }
        if (writer = this.logWriters[logType]) {
            writer(logText, cb);
        }
        else {
            cb && cb({
                "name": "BAD-LOG-TYPE",
                "message": "Specific log writer is not found."
            });
        }
    };
    ConsoleLogger.prototype.logSync = function (logText, logType) {
        var writer;
        if (!logType) {
            logType = this.defType;
        }
        if (writer = this.logWriters[logType]) {
            writer(logText, void 0);
        }
        else {
            throw {
                "name": "BAD-LOG-TYPE",
                "message": "Specific log writer is not found."
            };
        }
    };
    return ConsoleLogger;
}(loggers.LoggerBase));
module.exports = ConsoleLogger;
//# sourceMappingURL=class.ConsoleLogger.js.map